aboutsummaryrefslogtreecommitdiff
path: root/git-fetch.sh
diff options
context:
space:
mode:
authorPaolo Bonzini <bonzini@gnu.org>2007-03-15 09:23:20 +0100
committerJunio C Hamano <junkio@cox.net>2007-03-16 02:10:12 -0700
commit9debc3241b5d54891600c839b4df4f48b2daa60c (patch)
tree90fd68823d2d66689fedb191011b73373510a845 /git-fetch.sh
parent803527f1d9b284fa848d4a4bad23158c162a5d54 (diff)
downloadgit-9debc3241b5d54891600c839b4df4f48b2daa60c.tar.gz
git-9debc3241b5d54891600c839b4df4f48b2daa60c.tar.xz
git-fetch, git-branch: Support local --track via a special remote '.'
This patch adds support for a dummy remote '.' to avoid having to declare a fake remote like [remote "local"] url = . fetch = refs/heads/*:refs/heads/* Such a builtin remote simplifies the operation of "git-fetch", which will populate FETCH_HEAD but will not pretend that two repositories are in use, will not create a thin pack, and will not perform any useless remapping of names. The speed improvement is around 20%, and it should improve more if "git-fetch" is converted to a builtin. To this end, git-parse-remote is grown with a new kind of remote, 'builtin'. In git-fetch.sh, we treat the builtin remote specially in that it needs no pack/store operations. In fact, doing git-fetch on a builtin remote will simply populate FETCH_HEAD appropriately. The patch also improves of the --track/--no-track support, extending it so that branch.<name>.remote items referring '.' can be created. Finally, it fixes a typo in git-checkout.sh. Signed-off-by: Paolo Bonzini <bonzini@gnu.org> Signed-off-by: Junio C Hamano <junkio@cox.net>
Diffstat (limited to 'git-fetch.sh')
-rwxr-xr-xgit-fetch.sh12
1 files changed, 7 insertions, 5 deletions
diff --git a/git-fetch.sh b/git-fetch.sh
index 9d45dd266..e21804284 100755
--- a/git-fetch.sh
+++ b/git-fetch.sh
@@ -157,7 +157,7 @@ then
fi
fi
-fetch_native () {
+fetch_all_at_once () {
eval=$(echo "$1" | git-fetch--tool parse-reflist "-")
eval "$eval"
@@ -165,7 +165,9 @@ fetch_native () {
( : subshell because we muck with IFS
IFS=" $LF"
(
- if test -f "$remote" ; then
+ if test "$remote" = . ; then
+ git-show-ref $rref || echo failed "$remote"
+ elif test -f "$remote" ; then
test -n "$shallow_depth" &&
die "shallow clone with bundle is not supported"
git-bundle unbundle "$remote" $rref ||
@@ -188,7 +190,7 @@ fetch_native () {
}
-fetch_dumb () {
+fetch_per_ref () {
reflist="$1"
refs=
rref=
@@ -292,10 +294,10 @@ fetch_dumb () {
fetch_main () {
case "$remote" in
http://* | https://* | ftp://* | rsync://* )
- fetch_dumb "$@"
+ fetch_per_ref "$@"
;;
*)
- fetch_native "$@"
+ fetch_all_at_once "$@"
;;
esac
}